const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class SubscriptionsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const subscriptions = await db.subscriptions.create(
      {
        id: data.id || undefined,

        status: data.status || null,
        trial_ends_at: data.trial_ends_at || null,
        current_period_start: data.current_period_start || null,
        current_period_end: data.current_period_end || null,
        cancel_at_period_end: data.cancel_at_period_end || false,

        psp_customer_id: data.psp_customer_id || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await subscriptions.setUser(data.user || null, {
      transaction,
    });

    await subscriptions.setPlan(data.plan || null, {
      transaction,
    });

    await subscriptions.setOrganizations(data.organizations || null, {
      transaction,
    });

    return subscriptions;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const subscriptionsData = data.map((item, index) => ({
      id: item.id || undefined,

      status: item.status || null,
      trial_ends_at: item.trial_ends_at || null,
      current_period_start: item.current_period_start || null,
      current_period_end: item.current_period_end || null,
      cancel_at_period_end: item.cancel_at_period_end || false,

      psp_customer_id: item.psp_customer_id || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const subscriptions = await db.subscriptions.bulkCreate(subscriptionsData, {
      transaction,
    });

    // For each item created, replace relation files

    return subscriptions;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const subscriptions = await db.subscriptions.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.status !== undefined) updatePayload.status = data.status;

    if (data.trial_ends_at !== undefined)
      updatePayload.trial_ends_at = data.trial_ends_at;

    if (data.current_period_start !== undefined)
      updatePayload.current_period_start = data.current_period_start;

    if (data.current_period_end !== undefined)
      updatePayload.current_period_end = data.current_period_end;

    if (data.cancel_at_period_end !== undefined)
      updatePayload.cancel_at_period_end = data.cancel_at_period_end;

    if (data.psp_customer_id !== undefined)
      updatePayload.psp_customer_id = data.psp_customer_id;

    updatePayload.updatedById = currentUser.id;

    await subscriptions.update(updatePayload, { transaction });

    if (data.user !== undefined) {
      await subscriptions.setUser(
        data.user,

        { transaction },
      );
    }

    if (data.plan !== undefined) {
      await subscriptions.setPlan(
        data.plan,

        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await subscriptions.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return subscriptions;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const subscriptions = await db.subscriptions.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of subscriptions) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of subscriptions) {
        await record.destroy({ transaction });
      }
    });

    return subscriptions;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const subscriptions = await db.subscriptions.findByPk(id, options);

    await subscriptions.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await subscriptions.destroy({
      transaction,
    });

    return subscriptions;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const subscriptions = await db.subscriptions.findOne(
      { where },
      { transaction },
    );

    if (!subscriptions) {
      return subscriptions;
    }

    const output = subscriptions.get({ plain: true });

    output.payment_transactions_subscription =
      await subscriptions.getPayment_transactions_subscription({
        transaction,
      });

    output.user = await subscriptions.getUser({
      transaction,
    });

    output.plan = await subscriptions.getPlan({
      transaction,
    });

    output.organizations = await subscriptions.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.users,
        as: 'user',

        where: filter.user
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.user
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  firstName: {
                    [Op.or]: filter.user
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.plans,
        as: 'plan',

        where: filter.plan
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.plan
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  name: {
                    [Op.or]: filter.plan
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.psp_customer_id) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'subscriptions',
            'psp_customer_id',
            filter.psp_customer_id,
          ),
        };
      }

      if (filter.trial_ends_atRange) {
        const [start, end] = filter.trial_ends_atRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            trial_ends_at: {
              ...where.trial_ends_at,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            trial_ends_at: {
              ...where.trial_ends_at,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.current_period_startRange) {
        const [start, end] = filter.current_period_startRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            current_period_start: {
              ...where.current_period_start,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            current_period_start: {
              ...where.current_period_start,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.current_period_endRange) {
        const [start, end] = filter.current_period_endRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            current_period_end: {
              ...where.current_period_end,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            current_period_end: {
              ...where.current_period_end,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.status) {
        where = {
          ...where,
          status: filter.status,
        };
      }

      if (filter.cancel_at_period_end) {
        where = {
          ...where,
          cancel_at_period_end: filter.cancel_at_period_end,
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.subscriptions.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('subscriptions', 'status', query),
        ],
      };
    }

    const records = await db.subscriptions.findAll({
      attributes: ['id', 'status'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['status', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.status,
    }));
  }
};
